//
//  ADAvatar.h
//  TwitterGame
//
//Copyright (C) 2009 Amanda Wixted and David Cairns
//
//This program is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.
//
//This program is distributed in the hope that it will be
//useful, but WITHOUT ANY WARRANTY; without even the implied
//warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//See the GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program.  If not, see <http://www.gnu.org/licenses/>.


#import <Foundation/Foundation.h>
#import "ADCharacter.h"

// Delete this?
#import "ADPlatform.h"

@class GLTexture;

@interface ADAvatar : ADCharacter {
	CGPoint nextPosition;
	CGFloat yVelocity;
	
	BOOL canJump;
	
	BOOL isCollidingWithSpammer;
}

@property CGPoint nextPosition;
@property BOOL isCollidingWithSpammer;

@property (readonly) CGPoint bottomLeft; 
@property (readonly) CGPoint bottomRight;
@property (readonly) CGPoint nextBottomLeft;
@property (readonly) CGPoint nextBottomRight;


-(void) doRunWithForce:(float)force;
-(void) doJumpWithSpeed:(float)swipeSpeed;
-(BOOL) isBelowViewableFrame:(CGRect)viewable;


@end
